]> git.saurik.com Git - bison.git/blobdiff - tests/synclines.at
Don't leak semantic values for parent RHS when a user action cuts the
[bison.git] / tests / synclines.at
index ea6f968808fc95cadece7807782a5292e283b098..5ecbdb3cb6ef6ec7f028b10f1c8e5c06e197572f 100644 (file)
@@ -1,5 +1,5 @@
 # Executing Actions.                               -*- Autotest -*-
-# Copyright (C) 2002 Free Software Foundation, Inc.
+# Copyright (C) 2002, 2004, 2005 Free Software Foundation, Inc.
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
-# 02111-1307, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 AT_BANNER([[User Actions.]])
 
+
+# AT_SYNCLINES_COMPILE(FILE)
+# --------------------------
+# Compile FILE expecting an error, and save in the file stdout the
+# normalized output.  Ignore the exit status, since some compilers
+# (e.g. c89 on IRIX 6.5) triger warnings on `#error', instead of
+# errors.
+m4_define([AT_SYNCLINES_COMPILE],
+[AT_CHECK([$CC $CFLAGS $CPPFLAGS -c $1], [ignore], [], [stderr])
+# In case GCC displays column information, strip it down.
+#
+#   input.y:4:2: #error "4"    or
+#   input.y:4.2: #error "4"    or
+#   input.y:4:2: error: #error "4"
+# =>
+#   input.y:4: #error "4"
+#
+AT_CHECK([[sed -e 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' -e 's/^\([^:]*:[^:]*:\)[^@%:@]*\( @%:@error\)/\1\2/' stderr]], 0, [stdout])
+])
+
 # AT_TEST_SYNCLINE(TITLE, INPUT, ERROR-MSG)
 # -----------------------------------------
 # Check that compiling the parser produced from INPUT cause GCC
@@ -25,23 +45,34 @@ AT_BANNER([[User Actions.]])
 m4_define([AT_TEST_SYNCLINE],
 [AT_SETUP([$1])
 
-# I'm not sure I can find a generic scheme to check the location
-# of an error, so we keep this for GCC only.
-AT_CHECK([test "$GCC" = yes || exit 77])
-
-AT_DATA([[input.y]],
-[$2])
-
-AT_CHECK([bison input.y -o input.c])
-AT_CHECK([$CC $CFLAGS $CPPFLAGS input.c -c], 1, [], [stderr])
-# In case GCC displays column information, strip it down.
+# It seems impossible to find a generic scheme to check the location
+# of an error.  Even requiring GCC is not sufficient, since for instance
+# the version modified by Apple:
 #
-#   input.y:4:2: #error "4"    or input.y:4.2: #error "4"
-# =>
-#   input.y:4: #error "4"
+# | Reading specs from /usr/libexec/gcc/darwin/ppc/2.95.2/specs
+# | Apple Computer, Inc. version gcc-934.3, based on gcc version 2.95.2
+# | 19991024 (release) configure:2124: $? = 0
+#
+# instead of:
+#
+# | input.y:2: #error "2"
 #
-AT_CHECK([[sed 's/^\([^:]*:[^:.]*\)[.:][^:]*:\(.*\)$/\1:\2/' stderr]],
-         0, [$3])
+# it reports:
+#
+# | input.y:2: "2"
+# | cpp-precomp: warning: errors during smart preprocessing, retrying in basic mode
+
+AT_DATA([syncline.c],
+[[#error "1"
+]])
+
+AT_SYNCLINES_COMPILE([syncline.c])
+AT_CHECK([[test "`cat stdout`" = 'syncline.c:1: @%:@error "1"' || exit 77]])
+
+AT_DATA([[input.y]], [$2])
+AT_CHECK([bison -o input.c input.y])
+AT_SYNCLINES_COMPILE([input.c])
+AT_CHECK([cat stdout], 0, [$3])
 AT_CLEANUP
 ])
 
@@ -71,6 +102,7 @@ exp: '0';
 AT_TEST_SYNCLINE([%union synch line],
 [[%union {
 #error "2"
+  char dummy;
 }
 %{
 void yyerror (const char *s);